//
//  firstViewController.m
//  TestCoreAnimation
//
//  Created by 黄梦炜 on 2017/11/27.
//  Copyright © 2017年 黄梦炜. All rights reserved.
//

#import "firstViewController.h"
#import "firstViewModel.h"
#import "pushToViewController.h"
#import "PushTransition.h"
NSString *const fromViewController = @"fromViewController";
@interface firstViewController ()<firstDelegate,UINavigationControllerDelegate>
@property (nonatomic, strong) firstViewModel *viewModel;

@end

@implementation firstViewController

-(void)viewDidAppear:(BOOL)animated{
    [super viewDidAppear:animated];
    self.navigationController.delegate = self;
}

-(void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    if (self.navigationController.delegate == self) {
        self.navigationController.delegate = nil;
    }
}

- (id<UIViewControllerAnimatedTransitioning>)navigationController:(UINavigationController *)navigationController
                                  animationControllerForOperation:(UINavigationControllerOperation)operation
                                               fromViewController:(UIViewController *)fromVC
                                                 toViewController:(UIViewController *)toVC {
    if (fromVC == self && [toVC isKindOfClass:[pushToViewController class]]) {
        return [[PushTransition alloc] init];
    }
    else {
        return nil;
    }
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.view setBackgroundColor:[UIColor whiteColor]];
    
    [self setUpView];
    // Do any additional setup after loading the view.
}
-(firstViewModel *)viewModel
{
    if (_viewModel == nil) {
        _viewModel = [[firstViewModel alloc] init];
        objc_setAssociatedObject(_viewModel, &fromViewController, self, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
        _viewModel.delegate = self;
    }
    return _viewModel;
}

-(void)setUpView
{
    _table = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, screen_width, screen_height) style:UITableViewStylePlain];
    [self.view addSubview:_table];
    [self.viewModel createTable:_table];
    [self.viewModel getModelDate];
    [_table reloadData];
}

-(void)clickRow:(NSInteger)row firstModel:(firstModel *)model
{
   
    
    pushToViewController *push = [[pushToViewController alloc] init];
    push.model = model;
    [self.navigationController pushViewController:push animated:YES];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
